<template>
<div>
    <v-toolbar color="primary" dark>
        <v-toolbar-title class="white--text">APPROVE PURCHASE ORDER JASA</v-toolbar-title>
        <v-spacer></v-spacer>
    </v-toolbar>

    <v-card class="pa-2">
        <v-layout row align-center>
            <v-flex xs3>
                <v-menu
                    v-model="menuStartdateFilter" offset-y lazy min-width="290px"
                    transition="scale-transition" max-width="290px" full-width
                    :nudge-right="40" :close-on-content-click="false"
                >
                    <template v-slot:activator="{on}">
                        <v-text-field
                            v-model="formattedStartdate" label="Tanggal Awal"
                            hide-details readonly v-on="on" outline
                        ></v-text-field>
                    </template>
                    <v-date-picker
                        v-model="filterjasa.startdate" no-title 
                        @input="menuStartdateFilter = false"
                    ></v-date-picker>
                </v-menu>
            </v-flex>
            <v-flex xs3 pl-2>
                <v-menu
                    v-model="menuEnddateFilter" offset-y lazy min-width="290px"
                    transition="scale-transition" max-width="290px" full-width 
                    :nudge-right="40" :close-on-content-click="false" 
                >
                    <template v-slot:activator="{on}">
                        <v-text-field 
                            v-model="formattedEnddate" label="Tanggal Akhir" 
                            hide-details readonly v-on="on" outline
                        ></v-text-field>
                    </template>
                    <v-date-picker
                        v-model="filterjasa.enddate" no-title 
                        @input="menuEnddateFilter = false"
                    ></v-date-picker>
                </v-menu>
            </v-flex>
            <v-flex xs3 pl-2>
                <v-autocomplete
                    :items="liststatus" hide-details outline 
                    v-model="filterjasa.status" label="Status"
                ></v-autocomplete>
            </v-flex>
            <v-flex xs3 pl-2>
                <v-text-field
                    v-model="filterjasa.search" hide-details outline 
                    label="Cari" placeholder="cai nomor po..."
                ></v-text-field>
            </v-flex>
        </v-layout>
    </v-card>

    <v-card class="pa-2 mt-2">
        <v-data-table
            :headers="headers" :items="list_pojasa.records" 
            class="elevation-1" hide-actions
        >
            <template v-slot:items="props">
            <tr>
                <td class="text-xs-center pa-2">{{ props.item.PurchaseOrderNumber }}</td>
                <td class="text-xs-center pa-2">{{ props.item.PurchaseOrderDate }}</td>
                <td class="text-xs-center pa-2">{{ props.item.SupplierName }}</td>
                <td class="text-xs-center pa-2">{{ props.item.M_BranchName }}</td>
                <td class="text-xs-center pa-2">{{ props.item.PurchaseOrderNote }}</td>
                <td class="text-xs-center pa-2">
                    Rp. {{ formatCurrency(props.item.PurchaseOrderGrandTotal) }}
                </td>
                <td class="text-xs-center pa-2">{{ props.item.PurchaseOrderStatus }}</td>
                <td class="text-xs-center pa-2">
                    <v-layout 
                        v-if="props.item.PurchaseOrderStatus != 'Draft'"
                        align-center justify-center row
                    >
                        <v-flex shrink pr-1>
                            <v-btn
                                color="warning" @click="viewdetail(props.item)" small
                            >
                                detail
                                <v-icon small right>list_alt</v-icon>
                            </v-btn>
                            <v-chip
                                v-if="props.item.approvedby != '0'"
                                label color="success" text-color="white"
                            >
                                APPROVED
                            </v-chip>
                        </v-flex>
                        <v-flex pl-1 v-if="props.item.approvedby == '0'">
                            <v-btn
                                color="info" @click="updateStatusPO(props.item)" small
                                :disabled="userinfo.M_UserM_ApproveLevelID != '1'"
                                :outline="props.item.verifiedby == '0'"
                            >
                                verifikasi
                                <v-icon small right>done</v-icon>
                            </v-btn>
                            <v-btn
                                color="success" @click="updateStatusPO(props.item)" small
                                :disabled="userinfo.M_UserM_ApproveLevelID != '2'"
                                :outline="props.item.PurchaseOrderStatus != 'Approved'"
                            >
                                approve
                                <v-icon small right>done_all</v-icon>
                            </v-btn>
                        </v-flex>
                    </v-layout>
                </td>
            </tr>
            </template>
        </v-data-table>
        <v-divider class="my-1"></v-divider>
        <div class="po-2 mt-1 text-xs-center">
            <v-pagination v-model="currpage" :length="pagelength" :total-visible="10"></v-pagination>
        </div>
    </v-card>

    <v-snackbar v-model="snackbar.state" multi-line top :timeout="3000" :color="snackbar.color">
        {{ snackbar.msg }}
        <v-btn class="ml-2" round flat @click="snackbar.state = false">Tutup</v-btn>
    </v-snackbar>

    <dialog-confirm></dialog-confirm>
    <dialog-attachs></dialog-attachs>
</div>
</template>

<script>
module.exports = {
    components: {
        'dialog-confirm': httpVueLoader('./dialog-confirm.vue'),
        'dialog-attachs': httpVueLoader('./dialog-view-attachment.vue')
    },
    mounted() {
        this.$store.dispatch("poservice/lookupVendor")
        this.$store.dispatch("poservice/lookupCabang")
        this.$store.dispatch("poservice/lookupPOJasa")
        this.$store.dispatch("poservice/lookupUserApproveLevel")
    },
    data() {
        return {
            menuStartdateFilter: false,
            menuEnddateFilter: false,
            headers: [
                {
                    text: "No PO", align: "center", sortable: false,
                    value: "action", width: "15%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "TANGGAL", align: "center", sortable: false,
                    value: "date", width: "10%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "VENDOR", align: "center", sortable: false,
                    value: "supplier", width: "15%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "CABANG", align: "center", sortable: false,
                    value: "branch", width: "10%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "KETERANGAN", align: "center", sortable: false,
                    value: "note", width: "20%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "TOTAL", align: "center", sortable: false,
                    value: "total", width: "10%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "STATUS", align: "center", sortable: false,
                    value: "status", width: "7%", class: "pa-1 blue lighten-3 white--text",
                },
                {
                    text: "AKSI", align: "center", sortable: false,
                    value: "action", width: "13%", class: "pa-1 blue lighten-3 white--text",
                },
            ]
        }
    },
    computed: {
        filterjasa: {
            get() {
                return this.$store.state.poservice.filterjasa;
            },
            set(val) {
                this.$store.commit("poservice/update_filterjasa", val);
            }
        },
        formattedStartdate() {
            return this.formatDate(this.filterjasa.startdate)
        },
        formattedEnddate() {
            return this.formatDate(this.filterjasa.enddate)
        },
        liststatus() {
            return this.$store.state.poservice.liststatus
        },
        list_pojasa() {
            return this.$store.state.poservice.list_pojasa
        },
        pagelength() {
            let total = this.list_pojasa.total
            if (total === undefined || total < 1) return 1
            return Math.ceil(total/10)
        },
        userinfo() {
            return this.$store.state.poservice.userinfo
        },
        loading_process() {
            return this.$store.state.poservice.loading_process
        },
        currpage: {
            get() {
                return this.$store.state.poservice.currpage
            },
            set(val) {
                this.$store.commit("poservice/update_currpage", val)
                this.$store.dispatch("poservice/lookupPOJasa")
            }
        },
        snackbar: {
            get() {
                return this.$store.state.poservice.snackbar
            },
            set(val) {
                this.$store.commit("poservice/update_snackbar", val)
            }
        }
    },
    methods: {
        formatDate(date) {
            if (!date) return null;
            const [year, month, day] = date.split('-');
            return `${day}-${month}-${year}`;
        },
        formatCurrency(value) {
            const num = parseFloat(value);
            if (isNaN(num)) return 0;
            return num.toFixed(2).replace('.', ',').replace(/\B(?=(\d{3})+(?!\d))/g, ".");
        },
        updateStatusPO(item) {
            let poid = item.PurchaseOrderID
            let userlevel = this.userinfo.M_UserM_ApproveLevelID
            if (item.verifiedby == '0' || userlevel != '1') {
                this.$store.dispatch("poservice/lookupDetailPO", poid)
                this.$store.commit("poservice/update_detail_view", false)
                this.$store.commit("poservice/update_dialog_confirm", true)   
            } else {
                let snac = {color: 'info', msg: 'po sudah diverifikasi', state: true}
                this.snackbar = snac
            }
        },
        viewdetail(item) {
            this.$store.dispatch("poservice/lookupDetailPO", item.PurchaseOrderID)
            this.$store.commit("poservice/update_detail_view", true)
            this.$store.commit("poservice/update_dialog_confirm", true)
        }
    },
    watch: {
        filterjasa: {
            handler(val) {
                this.$store.dispatch("poservice/lookupPOJasa")
            },
            deep: true
        }
    },
}
</script>